package me.Demon.AskyBlockWarps.Listener;

import com.wasteofplastic.askyblock.ASkyBlockAPI;
import me.Demon.AskyBlockWarps.Main;
import me.Demon.AskyBlockWarps.Util.itemUtil;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.util.UUID;

public class LandTeamGui implements Listener {
    public static String invtitle = "帝国战争 - 空岛成员";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getInventory() != null && e.getInventory().getTitle().contains(invtitle)) {
            e.setCancelled(true);
            ItemStack item = e.getCurrentItem();
            if (e.getRawSlot() >= 0 && e.getRawSlot() < e.getInventory().getSize() && !DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
                if (ASkyBlockAPI.getInstance().getOwner(p.getLocation()).equals(p.getUniqueId())) {
                    String playName = item.getItemMeta().getDisplayName().replace("§6§l成员 §e", "");
                    p.performCommand("is expel " + playName);
                }
            } else {
                p.sendMessage(Main.prefix + "您不是岛主,没权限将玩家移出岛屿.");
                p.closeInventory();
            }
        }
    }

    public static void Opengui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 27, invtitle);
        for (UUID uid : ASkyBlockAPI.getInstance().getTeamMembers(p.getUniqueId())) {
            inv.addItem(itemUtil.teamList(Main.convertUUIDToName(uid)));
        }
        p.openInventory(inv);
    }
}
