package me.Demon.AskyBlockWarps.Listener;

import cn.hamster3.cdapi.CDTimeAPI;
import com.wasteofplastic.askyblock.ASkyBlockAPI;
import me.Demon.AskyBlockWarps.Main;
import me.Demon.AskyBlockWarps.Util.itemUtil;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Sound;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.util.UUID;

public class MainGui implements Listener {
    public static String invtitle = "帝国战争 - 空岛管理";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getInventory() != null && e.getInventory().getTitle().contains(invtitle)) {
            e.setCancelled(true);
            ItemStack item = e.getCurrentItem();
            if (e.getRawSlot() >= 0 && e.getRawSlot() < e.getInventory().getSize() && !DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
                UUID islandOwner = ASkyBlockAPI.getInstance().getOwner(p.getLocation());
                if (e.getRawSlot() == 1) {
                    p.performCommand("is");
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.0F, 2.0F);
                    p.closeInventory();
                }

                if (e.getRawSlot() == 3) {
                    if (islandOwner != null && islandOwner.equals(p.getUniqueId())) {
                        if (CDTimeAPI.getCD(p.getUniqueId(), "islandsetwarp") < 0) {
                            SetLocation("Stats." + p.getName(), p.getLocation());
                            p.sendMessage(Main.prefix + "设置空岛地标点成功.");
                            CDTimeAPI.setPlayerCD(p.getUniqueId(), "islandsetwarp", 1000 * 3);
                            p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.0F, 2.0F);
                            p.closeInventory();
                        } else {
                            p.sendMessage(Main.prefix + "功能冷却中...");
                            p.closeInventory();
                        }
                    } else {
                        p.sendMessage(Main.prefix + "您只能在您的岛屿设置传送点地标.");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.0F, 2.0F);
                        p.closeInventory();
                    }
                }

                if (e.getRawSlot() == 5) {
                    WarpGui.Opengui(p);
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.0F, 2.0F);
                }

                if (e.getRawSlot() == 7) {
                    DemonAPI.sendTitle(p, 10, 20, 10, "§c§l空岛重置", "§6请联系群客服进行重置");
                    p.sendMessage(Main.prefix + "请联系客服进行空岛重置报备！！！");
                    p.sendMessage(Main.prefix + "请联系客服进行空岛重置报备！！！");
                    p.sendMessage(Main.prefix + "请联系客服进行空岛重置报备！！！");
                    p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.0F, 2.0F);
                    p.closeInventory();
                }

                if (e.getRawSlot() == 11) {
                    p.performCommand("is top");
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.0F, 2.0F);
                    p.closeInventory();
                }

                if (e.getRawSlot() == 13) {
                    Bukkit.dispatchCommand(Bukkit.getConsoleSender(), "asadmin lock " + p.getName());
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.0F, 2.0F);
                    p.closeInventory();
                }

                if (e.getRawSlot() == 15) {
                    LandTeamGui.Opengui(p);
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.0F, 2.0F);
                }
                if (e.getRawSlot() == 19) {
                    LandInviteGui.Opengui(p);
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.0F, 2.0F);
                }
                if (e.getRawSlot() == 25) {
                    p.performCommand("challenge");
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.0F, 2.0F);
                }
            }
        }
    }

    public static void Opengui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 27, invtitle);
        boolean butt = ASkyBlockAPI.getInstance().hasIsland(p.getUniqueId());

        inv.setItem(1, itemUtil.backisland(butt));
        inv.setItem(3, itemUtil.setWarp());
        inv.setItem(5, itemUtil.warpList());
        inv.setItem(7, itemUtil.resetLand());
        inv.setItem(11, itemUtil.looklandlevel(p, butt));
        inv.setItem(13, itemUtil.islandlock());
        inv.setItem(15, itemUtil.islandlook(butt));
        inv.setItem(19, itemUtil.isLandinvite());
        inv.setItem(25, itemUtil.islandQuest());

        p.openInventory(inv);
    }

    public void SetLocation(String key, Location loc) {
        FileConfiguration yml = Main.plugin.getConfig();
        yml.set(key + ".world", loc.getWorld().getName());
        yml.set(key + ".x", loc.getX());
        yml.set(key + ".y", loc.getY());
        yml.set(key + ".z", loc.getZ());
        yml.set(key + ".yaw", loc.getYaw());
        yml.set(key + ".pitch", loc.getPitch());
        Main.plugin.saveConfig();
    }
}
