package me.Demon.AskyBlockWarps.Listener;

import com.wasteofplastic.askyblock.ASkyBlockAPI;
import me.Demon.AskyBlockWarps.Main;
import me.Demon.AskyBlockWarps.Util.itemUtil;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.util.ArrayList;
import java.util.List;

public class LandInviteGui implements Listener {
    public static String invtitle = "帝国战争 - 成员邀请";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getInventory() != null && e.getInventory().getTitle().contains(invtitle)) {
            e.setCancelled(true);
            ItemStack item = e.getCurrentItem();
            if (e.getRawSlot() >= 0 && e.getRawSlot() < e.getInventory().getSize() && !DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
                if (ASkyBlockAPI.getInstance().getOwner(p.getLocation()).equals(p.getUniqueId())) {
                    String playName = item.getItemMeta().getDisplayName().replace("§6§l玩家 §e", "");
                    p.performCommand("is invite " + playName);
                } else {
                    p.sendMessage(Main.prefix + "您不是岛主,没权限邀请玩家加入岛屿.");
                    p.closeInventory();
                }
            }
        }
    }

    public static void Opengui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 54, invtitle);
        // 获取玩家附近20格内的所有玩家
        List<Player> nearbyPlayers = new ArrayList<>();
        for (Player nearbyPlayer : Bukkit.getServer().getOnlinePlayers()) {
            if (p.getWorld().equals(nearbyPlayer.getWorld())) { // 确保玩家在同一世界
                if (p.getLocation().distance(nearbyPlayer.getLocation()) <= 20) {
                    nearbyPlayers.add(nearbyPlayer);
                }
            }
        }

        for (Player nearbyPlayer : nearbyPlayers) {
            if (!p.equals(nearbyPlayer)) { // 避免将玩家自己添加到GUI中
                inv.addItem(itemUtil.addTeam(nearbyPlayer.getName()));
            }
        }

        p.openInventory(inv);
    }
}
