package me.Demon.AskyBlockWarps;

import me.Demon.AskyBlockWarps.Command.iswarpCommand;
import me.Demon.AskyBlockWarps.Listener.LandInviteGui;
import me.Demon.AskyBlockWarps.Listener.LandTeamGui;
import me.Demon.AskyBlockWarps.Listener.MainGui;
import me.Demon.AskyBlockWarps.Listener.WarpGui;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.OfflinePlayer;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.UUID;

public class Main extends JavaPlugin {
    public static Main plugin;
    public static String prefix = "§7[§6帝国战争§7] §f";

    @Override
    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        Bukkit.getServer().getPluginManager().registerEvents(new MainGui(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new WarpGui(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new LandTeamGui(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new LandInviteGui(), plugin);
        getCommand("iswarps").setExecutor(new iswarpCommand());
        getCommand("iswarps").setTabCompleter(new iswarpCommand());
    }

    @Override
    public void onDisable() {

    }

    public static String convertUUIDToName(UUID uuid) {
        OfflinePlayer offlinePlayer = Bukkit.getOfflinePlayer(uuid);
        return offlinePlayer.getName();
    }

    public static Location LandWarpLoc(String playName) {
        FileConfiguration yml = Main.plugin.getConfig();
        String w = yml.getString("Stats." + playName + ".world");
        double x = yml.getDouble("Stats." + playName + ".x");
        double y = yml.getDouble("Stats." + playName + ".y");
        double z = yml.getDouble("Stats." + playName + ".z");
        float pi = (float) yml.getDouble("Stats." + playName + ".pitch");
        float ya = (float) yml.getDouble("Stats." + playName + ".yaw");
        return new Location(Bukkit.getWorld(w), x, y, z, ya, pi);
    }
}
